Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle TopLink API Reference 10g Release 3 (10.1.3) B13698-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.toplink.sessions
Interface UnitOfWork

All Superinterfaces:
  Session

All Known Implementing Classes:
  UnitOfWork

public interface UnitOfWork
extends Session

Purpose: To allow object level transactions. This class represents the public API of the unit of work and should be used to maintain complete compatibility.

Description: The unit of work is a session that implements all of the normal protocol of a TopLink session. It can be spawned from any other session including another unit of work. Objects can be brought into the unit of work through reading them or through registering them. The unit of work will opperate on its own object space, that is the objects within the unit of work will be clones of the orignial objects. When the unit of work is commited, all changes to any objects registered within the unit of work will be commited to the database. A minimal commit/update will be performed and any foreign keys/circular reference/referencial integrity will be resolved. If the commit to the database is successful the changed objects will be merged back into the unit of work parent session.

Responsibilities:

- Allow parallel transactions against a session's objects.
- Allow nested transactions.
- Not require the application to write objects that is changes, automatically determine what has changed.
- Perform a minimal commit/update of all changes that occured.
- Resolve foreign keys for newly created objects and maintain referencial integrity.
- Allow for the object transaction to use its own object space.

Method Summary
`void` | `addReadOnlyClass(java.lang.Class theClass)` PUBLIC: Adds the given Java class to the receiver's set of read-only classes.
`void` | `addReadOnlyClasses(java.util.Vector classes)` PUBLIC: Adds the classes in the given Vector to the existing set of read-only classes.
`void` | `assignSequenceNumber(java.lang.Object object)` ADVANCED: Assign sequence number to the object.
`void` | `assignSequenceNumbers()` ADVANCED: Assign sequence numbers to all new objects registered in this unit of work, or any new objects reference by any objects registered.
`void` | `beginEarlyTransaction()` PUBLIC: Tell the unit of work to begin a transaction now.
`void` | `commit()` PUBLIC: Commit the unit of work to its parent.
`void` | `commitAndResume()` PUBLIC: Commit the unit of work to its parent.
`void` | `commitAndResumeOnFailure()` PUBLIC: Commit the unit of work to its parent.
`java.lang.Object` | `deepMergeClone(java.lang.Object rmiClone)` PUBLIC: Merge the attributes of the clone into the unit of work copy.
`java.lang.Object` | `deepRevertObject(java.lang.Object clone)` PUBLIC: Revert the object's attributes from the parent.
`void` | `deepUnregisterObject(java.lang.Object clone)` ADVANCED: Unregister the object with the unit of work.
`void` | `deleteAllObjects(java.util.Collection domainObjects)` PUBLIC: Delete all of the objects and all of their privately owned parts in the database.
`void` | `deleteAllObjects(java.util.Vector domainObjects)` PUBLIC: Delete all of the objects and all of their privately owned parts in the database.
`java.lang.Object` | `deleteObject(java.lang.Object domainObject)` PUBLIC: Delete the object and all of their privately owned parts in the database.
`void` | `dontPerformValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`void` | `forceUpdateToVersionField(java.lang.Object cloneFromUOW, boolean shouldModifyVersionField)` ADVANCED: Set optmistic read lock on the object.
`UnitOfWorkChangeSet` | `getCurrentChanges()` ADVANCED: This method Will Calculate the chages for the UnitOfWork.
`java.lang.Object` | `getOriginalVersionOfObject(java.lang.Object workingClone)` ADVANCED: Return the original version of the object(clone) from the parent's identity map.
`Session` | `getParent()` PUBLIC: Return the parent.
`UnitOfWorkChangeSet` | `getUnitOfWorkChangeSet()` ADVANCED: Returns the currentChangeSet from the UnitOfWork.
`int` | `getValidationLevel()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`boolean` | `hasChanges()` ADVANCED: The Unit of work is capable of preprocessing to determine if any on the clone have been changed.
`boolean` | `isActive()` PUBLIC: Return if the unit of work is active (has not been released).
`boolean` | `isClassReadOnly(java.lang.Class theClass)` PUBLIC: Checks to see if the specified class is read-only or not in this UnitOfWork.
`boolean` | `isNestedUnitOfWork()` ADVANCED: Return if this session is a nested unit of work.
`java.lang.Object` | `mergeClone(java.lang.Object rmiClone)` PUBLIC: Merge the attributes of the clone into the unit of work copy.
`java.lang.Object` | `mergeCloneWithReferences(java.lang.Object rmiClone)` PUBLIC: Merge the attributes of the clone into the unit of work copy.
`java.lang.Object` | `newInstance(java.lang.Class theClass)` PUBLIC: Return a new instance of the class registered in this unit of work.
`void` | `performFullValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`void` | `performPartialValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`void` | `printRegisteredObjects()` PUBLIC: Print the objects in the unit of work.
`java.lang.Object` | `refreshAndLockObject(java.lang.Object object)` PUBLIC: Refresh the attributes of the object and of all of its private parts from the database.
`java.lang.Object` | `refreshAndLockObject(java.lang.Object object, short lockMode)` PUBLIC: Refresh the attributes of the object and of all of its private parts from the database.
`java.util.Vector` | `registerAllObjects(java.util.Collection domainObjects)` PUBLIC: Register the objects with the unit of work.
`java.util.Vector` | `registerAllObjects(java.util.Vector domainObjects)` PUBLIC: Register the objects with the unit of work.
`java.lang.Object` | `registerExistingObject(java.lang.Object existingObject)` ADVANCED: Register the existing object with the unit of work.
`java.lang.Object` | `registerNewObject(java.lang.Object newObject)` ADVANCED: Register the new object with the unit of work.
`java.lang.Object` | `registerObject(java.lang.Object domainObject)` PUBLIC: Register the object with the unit of work.
`void` | `release()` PUBLIC: Release the unit of work.
`void` | `removeAllReadOnlyClasses()` PUBLIC: Empties the set of read-only classes.
`void` | `removeForceUpdateToVersionField(java.lang.Object cloneFromUOW)` ADVANCED: Remove optimistic read lock from the object See forceUpdateToVersionField(Object)
`void` | `removeReadOnlyClass(java.lang.Class theClass)` PUBLIC: Removes a Class from the receiver's set of read-only classes.
`void` | `revertAndResume()` PUBLIC: Revert all changes made to any registered object.
`java.lang.Object` | `revertObject(java.lang.Object clone)` PUBLIC: Revert the object's attributes from the parent.
`void` | `setShouldNewObjectsBeCached(boolean shouldNewObjectsBeCached)` ADVANCED: By default new objects are not cached until the exist on the database.
`void` | `setShouldPerformDeletesFirst(boolean shouldPerformDeletesFirst)` ADVANCED: By default deletes are performed last in a unit of work.
`void` | `setShouldThrowConformExceptions(int shouldThrowExceptions)` ADVANCED: Conforming queries can be set to provide different levels of detail about the exceptions they encounter There are three levels: DO_NOT_THROW_CONFORM_EXCEPTIONS = 0; THROW_ALL_CONFORM_EXCEPTIONS = 1;
`void` | `setValidationLevel(int validationLevel)` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`java.lang.Object` | `shallowMergeClone(java.lang.Object rmiClone)` PUBLIC: Merge the attributes of the clone into the unit of work copy.
`java.lang.Object` | `shallowRevertObject(java.lang.Object clone)` PUBLIC: Revert the object's attributes from the parent.
`void` | `shallowUnregisterObject(java.lang.Object clone)` ADVANCED: Unregister the object with the unit of work.
`boolean` | `shouldNewObjectsBeCached()` ADVANCED: By default new objects are not cached until the exist on the database.
`boolean` | `shouldPerformDeletesFirst()` ADVANCED: By default all objects are inserted and updated in the database before any object is deleted.
`boolean` | `shouldPerformFullValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`boolean` | `shouldPerformNoValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`boolean` | `shouldPerformPartialValidation()` ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache.
`void` | `unregisterObject(java.lang.Object clone)` ADVANCED: Unregister the object with the unit of work.
`void` | `validateObjectSpace()` ADVANCED: This can be used to help debugging an object-space corruption.
`void` | `writeChanges()` ADVANCED: Writes all changes now before commit().

Methods inherited from interface oracle.toplink.sessions.Session
`acquireHistoricalSession, acquireUnitOfWork, addQuery, clearIntegrityChecker, clearProfile, containsObjectInIdentityMap, containsObjectInIdentityMap, containsQuery, copyObject, copyObject, doesObjectExist, dontLogMessages, executeNonSelectingCall, executeNonSelectingSQL, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeQuery, executeSelectingCall, executeSQL, getActiveSession, getActiveUnitOfWork, getAllFromIdentityMap, getAllFromIdentityMap, getAsOfClause, getCacheSynchronizationManager, getClassDescriptor, getClassDescriptor, getClassDescriptorForAlias, getDatasourceLogin, getDescriptor, getDescriptor, getDescriptorForAlias, getDescriptors, getEventManager, getExceptionHandler, getExternalTransactionController, getFromIdentityMap, getFromIdentityMap, getFromIdentityMap, getFromIdentityMap, getIdentityMapAccessor, getIntegrityChecker, getLog, getLogin, getLogLevel, getLogLevel, getName, getNextSequenceNumberValue, getProfiler, getProject, getProperties, getProperty, getQueries, getQuery, getQuery, getSessionLog, getWriteLockValue, getWriteLockValue, handleException, handleSevere, hasCacheSynchronizationManager, hasDescriptor, hasExceptionHandler, hasExternalTransactionController, initializeAllIdentityMaps, initializeIdentityMap, initializeIdentityMaps, isClientSession, isConnected, isDatabaseSession, isDistributedSession, isInProfile, isRemoteSession, isRemoteUnitOfWork, isServerSession, isSessionBroker, isUnitOfWork, keyFromObject, log, log, logDebug, logDebug, logException, logMessage, logMessage, logMessages, printIdentityMap, printIdentityMaps, putInIdentityMap, putInIdentityMap, putInIdentityMap, readAllObjects, readAllObjects, readAllObjects, readAllObjects, readObject, readObject, readObject, readObject, readObject, refreshObject, removeFromIdentityMap, removeFromIdentityMap, removeProperty, removeQuery, setCacheSynchronizationManager, setExceptionHandler, setExternalTransactionController, setIntegrityChecker, setLog, setLogLevel, setName, setProfiler, setProperty, setSessionLog, setSessionLog, setShouldLogMessages, shouldLog, shouldLogMessages, updateWriteLockValue, updateWriteLockValue, usesExternalTransactionController, validateCache`

Method Detail

### addReadOnlyClass

    public void addReadOnlyClass(java.lang.Class theClass)

  PUBLIC: Adds the given Java class to the receiver's set of read-only classes. Cannot be called after objects have been registered in the unit of work.

### addReadOnlyClasses

    public void addReadOnlyClasses(java.util.Vector classes)

  PUBLIC: Adds the classes in the given Vector to the existing set of read-only classes. Cannot be called after objects have been registered in the unit of work.

### assignSequenceNumber

    public void assignSequenceNumber(java.lang.Object object)
                              throws DatabaseException

  ADVANCED: Assign sequence number to the object. This allows for an object's id to be assigned before commit. It can be used if the application requires to use the object id before the object exists on the database. Normally all ids are assigned during the commit automatically.
  Throws:
    `DatabaseException`

### assignSequenceNumbers

    public void assignSequenceNumbers()
                               throws DatabaseException

  ADVANCED: Assign sequence numbers to all new objects registered in this unit of work, or any new objects reference by any objects registered. This allows for an object's id to be assigned before commit. It can be used if the application requires to use the object id before the object exists on the database. Normally all ids are assigned during the commit automatically.
  Throws:
    `DatabaseException`

### beginEarlyTransaction

    public void beginEarlyTransaction()
                               throws DatabaseException

  PUBLIC: Tell the unit of work to begin a transaction now. By default the unit of work will begin a transaction at commit time. The default is the recommended approach, however sometimes it is neccessary to start the transaction before commit time. When the unit of work commits, this transcation will be commited.
  Throws:
    `DatabaseException`
  See Also:
    `commit()`, `release()`

### commit

    public void commit()
                throws DatabaseException,
                       OptimisticLockException

  PUBLIC: Commit the unit of work to its parent. For a nested unit of work this will merge any changes to its objects with its parents. For a first level unit of work it will commit all changes to its objects to the database as a single transaction. If successful the changes to its objects will be merged to its parent's objects. If the commit fails the database transaction will be rolledback, and the unit of work will be released. If the commit is successful the unit of work is released, and a new unit of work must be acquired if further changes are desired.
  Throws:
    `DatabaseException`
    `OptimisticLockException`
  See Also:
    `commitAndResumeOnFailure()`, `commitAndResume()`, `release()`

### commitAndResume

    public void commitAndResume()
                         throws DatabaseException,
                                OptimisticLockException

  PUBLIC: Commit the unit of work to its parent. For a nested unit of work this will merge any changes to its objects with its parents. For a first level unit of work it will commit all changes to its objects to the database as a single transaction. If successful the changes to its objects will be merged to its parent's objects. If the commit fails the database transaction will be rolledback, and the unit of work will be released. The normal commit releases the unit of work, forcing a new one to be acquired if further changes are desired. The resuming feature allows for the same unit of work (and working copies) to be continued to be used.
  Throws:
    `DatabaseException`
    `OptimisticLockException`
  See Also:
    `commitAndResumeOnFailure()`, `commit()`, `release()`

### commitAndResumeOnFailure

    public void commitAndResumeOnFailure()
                                  throws DatabaseException,
                                         OptimisticLockException

  PUBLIC: Commit the unit of work to its parent. For a nested unit of work this will merge any changes to its objects with its parents. For a first level unit of work it will commit all changes to its objects to the database as a single transaction. If successful the changes to its objects will be merged to its parent's objects. If the commit fails the database transaction will be rolledback, but the unit of work will remain active. It can then be retried or released. The normal commit failure releases the unit of work, forcing a new one to be acquired if further changes are desired. The resuming feature allows for the same unit of work (and working copies) to be continued to be used if an error occurs. The UnitOfWork will also remain active if the commit is successful.
  Throws:
    `DatabaseException`
    `OptimisticLockException`
  See Also:
    `commit()`, `release()`

### deepMergeClone

    public java.lang.Object deepMergeClone(java.lang.Object rmiClone)

  PUBLIC: Merge the attributes of the clone into the unit of work copy. This can be used for objects that are returned from the client through RMI serialization or other serialization mechanisms, because the RMI object will be a clone this will merge its attributes correctly to preserve object identity within the unit of work and record its changes. Everything connected to this object (i.e. the entire object tree where rmiClone is the root) is also merged.
  Returns:
    the registered version for the clone being merged.
  See Also:
    `mergeClone(Object)`, `shallowMergeClone(Object)`

### deepRevertObject

    public java.lang.Object deepRevertObject(java.lang.Object clone)

  PUBLIC: Revert the object's attributes from the parent. This reverts everything the object references.
  Returns:
    the object reverted.
  See Also:
    `revertObject(Object)`, `shallowRevertObject(Object)`

### deepUnregisterObject

    public void deepUnregisterObject(java.lang.Object clone)

  ADVANCED: Unregister the object with the unit of work. This can be used to delete an object that was just created and is not yet persistent. Delete object can also be used, but will result in inserting the object and then deleting it. The method should be used carefully because it will delete all the reachable parts.

### deleteAllObjects

    public void deleteAllObjects(java.util.Collection domainObjects)

  PUBLIC: Delete all of the objects and all of their privately owned parts in the database. Delete operations are delayed in a unit of work until commit.

### deleteAllObjects

    public void deleteAllObjects(java.util.Vector domainObjects)

  PUBLIC: Delete all of the objects and all of their privately owned parts in the database. Delete operations are delayed in a unit of work until commit.

### deleteObject

    public java.lang.Object deleteObject(java.lang.Object domainObject)

  PUBLIC: Delete the object and all of their privately owned parts in the database. Delete operations are delayed in a unit of work until commit.

### dontPerformValidation

    public void dontPerformValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### forceUpdateToVersionField

    public void forceUpdateToVersionField(java.lang.Object cloneFromUOW,
                                          boolean shouldModifyVersionField)

  ADVANCED: Set optmistic read lock on the object. This feature is overide by normal optimistic lock. when the object is changed in UnitOfWork. The cloneFromUOW must be the clone of from this UnitOfWork and it must implements version locking or timestamp locking. The SQL would look like the followings. If shouldModifyVersionField is true, "UPDATE EMPLOYEE SET VERSION = 2 WHERE EMP_ID = 9 AND VERSION = 1" If shouldModifyVersionField is false, "UPDATE EMPLOYEE SET VERSION = 1 WHERE EMP_ID = 9 AND VERSION = 1"

### getCurrentChanges

    public UnitOfWorkChangeSet getCurrentChanges()

  ADVANCED: This method Will Calculate the chages for the UnitOfWork. Without assigning sequence numbers This is a Computationaly intensive operation and should be avoided unless necessary. A valid changeSet, with sequencenumbers can be collected from the UnitOfWork After the commit is complete by calling unitOfWork.getUnitOfWorkChangeSet()

### getOriginalVersionOfObject

    public java.lang.Object getOriginalVersionOfObject(java.lang.Object workingClone)

  ADVANCED: Return the original version of the object(clone) from the parent's identity map.

### getParent

    public Session getParent()

  PUBLIC: Return the parent. This is a unit of work if nested, otherwise a database session or client session.

### getUnitOfWorkChangeSet

    public UnitOfWorkChangeSet getUnitOfWorkChangeSet()

  ADVANCED: Returns the currentChangeSet from the UnitOfWork. This is only valid after the UnitOfWOrk has commited successfully

### getValidationLevel

    public int getValidationLevel()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### hasChanges

    public boolean hasChanges()

  ADVANCED: The Unit of work is capable of preprocessing to determine if any on the clone have been changed. This is computationaly expensive and should be avoided on large object graphs.

### isActive

    public boolean isActive()

  PUBLIC: Return if the unit of work is active (has not been released).

### isClassReadOnly

    public boolean isClassReadOnly(java.lang.Class theClass)

  PUBLIC: Checks to see if the specified class is read-only or not in this UnitOfWork.
  Returns:
    true if the class is read-only, false otherwise.

### isNestedUnitOfWork

    public boolean isNestedUnitOfWork()

  ADVANCED: Return if this session is a nested unit of work.

### mergeClone

    public java.lang.Object mergeClone(java.lang.Object rmiClone)

  PUBLIC: Merge the attributes of the clone into the unit of work copy. This can be used for objects that are returned from the client through RMI serialization (or another serialization mechanism), because the RMI object will be a clone this will merge its attributes correctly to preserve object identity within the unit of work and record its changes. The object and its private owned parts are merged.
  Returns:
    the registered version for the clone being merged.
  See Also:
    `shallowMergeClone(Object)`, `deepMergeClone(Object)`

### mergeCloneWithReferences

    public java.lang.Object mergeCloneWithReferences(java.lang.Object rmiClone)

  PUBLIC: Merge the attributes of the clone into the unit of work copy. This can be used for objects that are returned from the client through RMI serialization (or another serialization mechanism), because the RMI object will be a clone this will merge its attributes correctly to preserve object identity within the unit of work and record its changes. The object and its private owned parts are merged. This will include references from this clone to independent objects.
  Returns:
    the registered version for the clone being merged.
  See Also:
    `shallowMergeClone(Object)`, `deepMergeClone(Object)`

### newInstance

    public java.lang.Object newInstance(java.lang.Class theClass)

  PUBLIC: Return a new instance of the class registered in this unit of work. This can be used to ensure that new objects are registered correctly.

### performFullValidation

    public void performFullValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### performPartialValidation

    public void performPartialValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### printRegisteredObjects

    public void printRegisteredObjects()

  PUBLIC: Print the objects in the unit of work.

### refreshAndLockObject

    public java.lang.Object refreshAndLockObject(java.lang.Object object)

  PUBLIC: Refresh the attributes of the object and of all of its private parts from the database. The object will be pessimisticly locked on the database for the duration of the transaction. If the object is already locked this method will wait until the lock is released. A no wait option is available through setting the lock mode.
  See Also:
    `#refreshAndLockObject(Object, lockMode)`

### refreshAndLockObject

    public java.lang.Object refreshAndLockObject(java.lang.Object object,
                                                 short lockMode)

  PUBLIC: Refresh the attributes of the object and of all of its private parts from the database. The object will be pessimisticly locked on the database for the duration of the transaction.

  Lock Modes: ObjectLevelReadQuery.NO_LOCK, LOCK, LOCK_NOWAIT

### registerAllObjects

    public java.util.Vector registerAllObjects(java.util.Collection domainObjects)

  PUBLIC: Register the objects with the unit of work. All newly created root domain objects must be registered to be inserted on commit. Also any existing objects that will be edited and were not read from this unit of work must also be registered. Once registered any changes to the objects will be commited to the database on commit.
  Returns:
    is the clones of the original objects, the return value must be used for editing, editing the original is not allowed in the unit of work.

### registerAllObjects

    public java.util.Vector registerAllObjects(java.util.Vector domainObjects)

  PUBLIC: Register the objects with the unit of work. All newly created root domain objects must be registered to be inserted on commit. Also any existing objects that will be edited and were not read from this unit of work must also be registered. Once registered any changes to the objects will be commited to the database on commit.
  Returns:
    is the clones of the original objects, the return value must be used for editing, editing the original is not allowed in the unit of work.

### registerExistingObject

    public java.lang.Object registerExistingObject(java.lang.Object existingObject)

  ADVANCED: Register the existing object with the unit of work. This is a advanced API that can be used if the application can guarentee the object exists on the database. When registerObject is called the unit of work determines existence through the descriptor's doesExist setting.
  Returns:
    The clone of the original object, the return value must be used for editing. Editing the original is not allowed in the unit of work.

### registerNewObject

    public java.lang.Object registerNewObject(java.lang.Object newObject)

  ADVANCED: Register the new object with the unit of work. This will register the new object without cloning. Normally the registerObject method should be used for all registration of new and existing objects. This version of the register method can only be used for new objects. This method should only be used if a new object is desired to be registered without cloning.
  See Also:
    `registerObject(Object)`

### registerObject

    public java.lang.Object registerObject(java.lang.Object domainObject)

  PUBLIC: Register the object with the unit of work. All newly created root domain objects must be registered to be inserted on commit. Also any existing objects that will be edited and were not read from this unit of work must also be registered. Once registered any changes to the objects will be commited to the database on commit.
  Returns:
    the clone of the original object, the return value must be used for editing, ** Editing the original is not allowed in the unit of work. **

### release

    public void release()

  PUBLIC: Release the unit of work. This terminates this unit of work. Because the unit of work operates on its own object space (clones) no work is required. The unit of work should no longer be used or referenced by the application beyond this point so that it can garbage collect.
  Specified by:
    `release` in interface `Session`
  See Also:
    `commit()`

### removeAllReadOnlyClasses

    public void removeAllReadOnlyClasses()

  PUBLIC: Empties the set of read-only classes. It is illegal to call this method on nested UnitOfWork objects. A nested UnitOfWork cannot have a subset of its parent's set of read-only classes.

### removeForceUpdateToVersionField

    public void removeForceUpdateToVersionField(java.lang.Object cloneFromUOW)

  ADVANCED: Remove optimistic read lock from the object See forceUpdateToVersionField(Object)

### removeReadOnlyClass

    public void removeReadOnlyClass(java.lang.Class theClass)

  PUBLIC: Removes a Class from the receiver's set of read-only classes. It is illegal to try to send this method to a nested UnitOfWork.

### revertAndResume

    public void revertAndResume()

  PUBLIC: Revert all changes made to any registered object. Clear all deleted and new objects. Revert should not be confused with release which it the normal compliment to commit. Revert is more similar to commit and resume, however reverts all changes and resumes. If you do not require to resume the unit of work release should be used instead.
  See Also:
    `commitAndResume()`, `release()`

### revertObject

    public java.lang.Object revertObject(java.lang.Object clone)

  PUBLIC: Revert the object's attributes from the parent. This also reverts the object privately-owned parts.
  Returns:
    the object reverted.
  See Also:
    `shallowRevertObject(Object)`, `deepRevertObject(Object)`

### setShouldNewObjectsBeCached

    public void setShouldNewObjectsBeCached(boolean shouldNewObjectsBeCached)

  ADVANCED: By default new objects are not cached until the exist on the database. Occasionally if mergeClone is used on new objects and is required to allow multiple merges on the same new object, then if the new objects are not cached, each mergeClone will be interpretted as a different new object. By setting new objects to be cached mergeClone can be performed multiple times before commit. New objects cannot be cached unless they have a valid assigned primary key before being registered. New object with non-null invalid primary keys such as 0 or '' can cause problems and should not be used with this option.

### setShouldPerformDeletesFirst

    public void setShouldPerformDeletesFirst(boolean shouldPerformDeletesFirst)

  ADVANCED: By default deletes are performed last in a unit of work. Sometimes you may want to have the deletes performed before other actions.

### setShouldThrowConformExceptions

    public void setShouldThrowConformExceptions(int shouldThrowExceptions)

  ADVANCED: Conforming queries can be set to provide different levels of detail about the exceptions they encounter There are three levels: DO_NOT_THROW_CONFORM_EXCEPTIONS = 0; THROW_ALL_CONFORM_EXCEPTIONS = 1;

### setValidationLevel

    public void setValidationLevel(int validationLevel)

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### shallowMergeClone

    public java.lang.Object shallowMergeClone(java.lang.Object rmiClone)

  PUBLIC: Merge the attributes of the clone into the unit of work copy. This can be used for objects that are returned from the client through RMI serialization (or other serialization mechanisms), because the RMI object will be a clone this will merge its attributes correctly to preserve object identity within the unit of work and record its changes. Only direct attributes are merged.
  Returns:
    the registered version for the clone being merged.
  See Also:
    `mergeClone(Object)`, `deepMergeClone(Object)`

### shallowRevertObject

    public java.lang.Object shallowRevertObject(java.lang.Object clone)

  PUBLIC: Revert the object's attributes from the parent. This only reverts the object's direct attributes.
  Returns:
    the object reverted.
  See Also:
    `revertObject(Object)`, `deepRevertObject(Object)`

### shallowUnregisterObject

    public void shallowUnregisterObject(java.lang.Object clone)

  ADVANCED: Unregister the object with the unit of work. This can be used to delete an object that was just created and is not yet persistent. Delete object can also be used, but will result in inserting the object and then deleting it. The method will only unregister the clone, none of its parts.

### shouldNewObjectsBeCached

    public boolean shouldNewObjectsBeCached()

  ADVANCED: By default new objects are not cached until the exist on the database. Occasionally if mergeClone is used on new objects and is required to allow multiple merges on the same new object, then if the new objects are not cached, each mergeClone will be interpretted as a different new object. By setting new objects to be cached mergeClone can be performed multiple times before commit. New objects cannot be cached unless they have a valid assigned primary key before being registered. New object with non-null invalid primary keys such as 0 or '' can cause problems and should not be used with this option.

### shouldPerformDeletesFirst

    public boolean shouldPerformDeletesFirst()

  ADVANCED: By default all objects are inserted and updated in the database before any object is deleted. If this flag is set to true, deletes will be performed before inserts and updates

### shouldPerformFullValidation

    public boolean shouldPerformFullValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### shouldPerformNoValidation

    public boolean shouldPerformNoValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### shouldPerformPartialValidation

    public boolean shouldPerformPartialValidation()

  ADVANCED: The unit of work performs validations such as, ensuring multiple copies of the same object don't exist in the same unit of work, ensuring deleted objects are not refered after commit, ensures that objects from the parent cache are not refered in the unit of work cache. The level of validation can be increased or decreased for debugging purposes or under advanced situation where the application requires/desires to violate clone identity in the unit of work. It is strongly suggested that clone identity not be violate in the unit of work.

### unregisterObject

    public void unregisterObject(java.lang.Object clone)

  ADVANCED: Unregister the object with the unit of work. This can be used to delete an object that was just created and is not yet persistent. Delete object can also be used, but will result in inserting the object and then deleting it. The method will only unregister private owned parts

### validateObjectSpace

    public void validateObjectSpace()

  ADVANCED: This can be used to help debugging an object-space corruption. An object-space corruption is when your application has incorrectly related a clone to an original object. This method will validate that all registered objects are in a correct state and throw an error if not, it will contain the full stack of object references in the error message. If you call this method after each register or change you perform it will pin-point where the error was made.

### writeChanges

    public void writeChanges()

  ADVANCED: Writes all changes now before commit(). The commit process will begin and all changes will be written out to the datastore, but the datastore transaction will not be committed, nor will changes be merged into the global cache.

  A subsequent commit (on UnitOfWork or global transaction) will be required to finalize the commit process.

  As the commit process has begun any attempt to register objects, or execute object-level queries will generate an exception. Report queries, non-caching queries, and data read/modify queries are allowed.

  On exception any global transaction will be rolled marked or marked rollback only. No recovery of this UnitOfWork will be possible.

  Can only be called once. It can not be used to write out changes in an incremental fashion.

  Use to partially commit a transaction outside of a JTA transaction's callbacks. Allows you to get back any exception directly.

  Use to commit a UnitOfWork in two stages.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 1998, 2006, Oracle. All Rights Reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD